ImmutableTypeToInstanceMap
Date: 2016-05-24

com.google.common.reflect

## Class ImmutableTypeToInstanceMap<B>

- java.lang.Object
- - com.google.common.collect.ForwardingObject
  - - com.google.common.collect.ForwardingMap<TypeToken<? extends B>,B>
    - - com.google.common.reflect.ImmutableTypeToInstanceMap<B>

- All Implemented Interfaces:
    TypeToInstanceMap<B>, java.util.Map<TypeToken<? extends B>,B>

      @Beta
      public final class ImmutableTypeToInstanceMap<B>
      extends ForwardingMap<TypeToken<? extends B>,B>
      implements TypeToInstanceMap<B>

  A type-to-instance map backed by an `ImmutableMap`. See also `MutableTypeToInstanceMap`.
  Since:
    13.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ImmutableTypeToInstanceMap.Builder<B>` A builder for creating immutable type-to-instance maps.

    - ### Nested classes/interfaces inherited from class com.google.common.collect.ForwardingMap

      `ForwardingMap.StandardEntrySet, ForwardingMap.StandardKeySet, ForwardingMap.StandardValues`

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `java.util.Map.Entry<K,V>`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <B> ImmutableTypeToInstanceMap.Builder<B>` | `builder()` Returns a new builder.
    `protected java.util.Map<TypeToken<? extends B>,B>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
    `<T extends B> T` | `getInstance(java.lang.Class<T> type)` Returns the value the specified class is mapped to, or `null` if no entry for this class is present.
    `<T extends B> T` | `getInstance(TypeToken<T> type)` Returns the value the specified type is mapped to, or `null` if no entry for this type is present.
    `static <B> ImmutableTypeToInstanceMap<B>` | `of()` Returns an empty type to instance map.
    `<T extends B> T` | `putInstance(java.lang.Class<T> type, T value)` Guaranteed to throw an exception and leave the map unmodified.
    `<T extends B> T` | `putInstance(TypeToken<T> type, T value)` Guaranteed to throw an exception and leave the map unmodified.

    - ### Methods inherited from class com.google.common.collect.ForwardingMap

      `clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, standardClear, standardContainsKey, standardContainsValue, standardEquals, standardHashCode, standardIsEmpty, standardPutAll, standardRemove, standardToString, values`

    - ### Methods inherited from class com.google.common.collect.ForwardingObject

      `toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Map

      `clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, values`

- - ### Method Detail

    - #### of

          public static <B> ImmutableTypeToInstanceMap<B> of()

      Returns an empty type to instance map.

    - #### builder

          public static <B> ImmutableTypeToInstanceMap.Builder<B> builder()

      Returns a new builder.

    - #### getInstance

          public <T extends B> T getInstance(TypeToken<T> type)

      Description copied from interface: `TypeToInstanceMap`
      Returns the value the specified type is mapped to, or `null` if no entry for this type is present. This will only return a value that was bound to this specific type, not a value that may have been bound to a subtype.
      Specified by:
        `getInstance` in interface `TypeToInstanceMap<B>`

    - #### putInstance

          public <T extends B> T putInstance(TypeToken<T> type,
                                    T value)

      Guaranteed to throw an exception and leave the map unmodified.
      Specified by:
        `putInstance` in interface `TypeToInstanceMap<B>`
      Returns:
        the value previously associated with this type (possibly `null`), or `null` if there was no previous entry.
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### getInstance

          public <T extends B> T getInstance(java.lang.Class<T> type)

      Description copied from interface: `TypeToInstanceMap`
      Returns the value the specified class is mapped to, or `null` if no entry for this class is present. This will only return a value that was bound to this specific class, not a value that may have been bound to a subtype.

      `getInstance(Foo.class)` is equivalent to `getInstance(TypeToken.of(Foo.class))`.

      Specified by:
        `getInstance` in interface `TypeToInstanceMap<B>`

    - #### putInstance

          public <T extends B> T putInstance(java.lang.Class<T> type,
                                    T value)

      Guaranteed to throw an exception and leave the map unmodified.
      Specified by:
        `putInstance` in interface `TypeToInstanceMap<B>`
      Returns:
        the value previously associated with this class (possibly `null`), or `null` if there was no previous entry.
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### delegate

          protected java.util.Map<TypeToken<? extends B>,B> delegate()

      Description copied from class: `ForwardingObject`
      Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.
      Specified by:
        `delegate` in class `ForwardingMap<TypeToken<? extends B>,B>`